#include <stdio.h>
#include <stdlib.h>

int main()
{
    int h,m,a,b,i,j,k,l,vodopad[100][100];
    scanf("%d",&h);
    scanf("%d",&m);


    for(a=1; a<=h; a++)
    {
        for(b=1; b<=m; b++)
        {
            scanf("%d",&vodopad[a][b]);
            vodopad[a][0]=0;
            vodopad[a][m+1]=0;
            vodopad[0][b]=1;
            vodopad[h+1][b]=1;

///if (vodopad[a][b]==0)
            /// vodopad[a+1][b]='0'; ako je nula tok ispovodopad je prazan!!!
        }
    }



    for (a=1; a<=m; a++)
    {
        for (b=1; b<=m; b++)
        {

            if (vodopad[a][b]==0)
            {
                if (vodopad[a-1][b]%2==1)
                {
                    if(a%2==1)
                    {

                        if (vodopad[a][b-1]==1 && vodopad[a][b+1]==1)
                        {
                            vodopad[a][b-1]+=1;



                        }
                        else
                        {
                            for(k=b-1,i=0; k>-1; k--)
                            {
                                if (vodopad[a][k]==1);
                                {
                                    goto gg;
                                }

                            if (vodopad[a][k]==0)
                                goto ff;
                                i++;
                            }
                           ff: for(l=b; k<m; l++)
                            {
                                if (vodopad[a][l]==1);
                                {
                                    goto cc;


                                }

                            }
                            cc: if (0)vodopad[a][l]+=i;
gg:
                             for(l=b; k<m; l++)
                            {
                                if (vodopad[a][l]==1);
                                {
                                    goto pp;


                                }
                                i++;
                            }
                            if(0)
                            {
pp:
                                vodopad[a][k]+=i/2;
                                vodopad[a][l]+=i/2;


                            }



                        }
                    }
                    else
                    {



                    }

                }
                else
                {









                }
                if (vodopad[a][b-1]==0)
                    vodopad [a][b+1]+= vodopad[a-1][b];
                if (vodopad[a][b+1]==0)
                    vodopad [a][b-1]+= vodopad[a-1][b];
            }

            if (vodopad[a][b]==1 && vodopad [a-1][b]!=0)
                vodopad[a][b] = vodopad[a-1][b];
        }
    }



    for(a=0; a<=h; a++)
    {
        for(b=0; b<=m+1; b++)
        {

            printf("%d ",vodopad[a][b]);

        }
        printf("\n");
    }

    return 0;
}
///vodopad[a+1][b]=0;